BooleanQuery (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.search, class: BooleanQuery

Package org.apache.lucene.search

# Class BooleanQuery

java.lang.Object
org.apache.lucene.search.Query
org.apache.lucene.search.BooleanQuery

All Implemented Interfaces:
  `Iterable<BooleanClause>`

public class BooleanQuery extends Query implements Iterable<BooleanClause>
A Query that matches documents matching boolean combinations of other queries, e.g. `TermQuery`s, `PhraseQuery`s or other BooleanQuerys.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `BooleanQuery.Builder`
  A builder for boolean queries.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<BooleanClause>`
  `clauses()`
  Return a list of the clauses of this `BooleanQuery`.
  `Weight`
  `createWeight(IndexSearcher searcher, ScoreMode scoreMode, float boost)`
  Expert: Constructs an appropriate Weight implementation for this query.
  `boolean`
  `equals(Object o)`
  Compares the specified object with this boolean query for equality.
  `Collection<Query>`
  `getClauses(BooleanClause.Occur occur)`
  Return the collection of queries for the given `BooleanClause.Occur`.
  `int`
  `getMinimumNumberShouldMatch()`
  Gets the minimum number of the optional BooleanClauses which must be satisfied.
  `int`
  `hashCode()`
  Override and implement query hash code properly in a subclass.
  `final Iterator<BooleanClause>`
  `iterator()`
  Returns an iterator on the clauses in this query.
  `Query`
  `rewrite(IndexSearcher indexSearcher)`
  Expert: called to re-write queries into primitive queries.
  `String`
  `toString(String field)`
  Prints a user-readable version of this query.
  `void`
  `visit(QueryVisitor visitor)`
  Recurse through the query tree, visiting any child queries.

  ### Methods inherited from class org.apache.lucene.search.Query

  `classHash, sameClassAs, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

- ## Method Details

  - ### getMinimumNumberShouldMatch

    public int getMinimumNumberShouldMatch()
    Gets the minimum number of the optional BooleanClauses which must be satisfied.

  - ### clauses

    public List<BooleanClause> clauses()
    Return a list of the clauses of this `BooleanQuery`.

  - ### getClauses

    public Collection<Query> getClauses(BooleanClause.Occur occur)
    Return the collection of queries for the given `BooleanClause.Occur`.

  - ### iterator

    public final Iterator<BooleanClause> iterator()
    Returns an iterator on the clauses in this query. It implements the `Iterable` interface to make it possible to do:

        for (BooleanClause clause : booleanQuery) {}

    Specified by:
      `iterator` in interface `Iterable<BooleanClause>`

  - ### createWeight

    public Weight createWeight(IndexSearcher searcher, ScoreMode scoreMode, float boost) throws IOException
    Description copied from class: `Query`
    Expert: Constructs an appropriate Weight implementation for this query.

    Only implemented by primitive queries, which re-write to themselves.

    Overrides:
      `createWeight` in class `Query`
    Parameters:
      `scoreMode` - How the produced scorers will be consumed.
      `boost` - The boost that is propagated by the parent queries.
    Throws:
      `IOException`

  - ### rewrite

    public Query rewrite(IndexSearcher indexSearcher) throws IOException
    Description copied from class: `Query`
    Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

    Callers are expected to call `rewrite` multiple times if necessary, until the rewritten query is the same as the original query.

    The rewrite process may be able to make use of IndexSearcher's executor and be executed in parallel if the executor is provided.

    Overrides:
      `rewrite` in class `Query`
    Throws:
      `IOException`
    See Also:
      - `IndexSearcher.rewrite(Query)`

  - ### visit

    public void visit(QueryVisitor visitor)
    Description copied from class: `Query`
    Recurse through the query tree, visiting any child queries.
    Specified by:
      `visit` in class `Query`
    Parameters:
      `visitor` - a QueryVisitor to be called by each query in the tree

  - ### toString

    public String toString(String field)
    Prints a user-readable version of this query.
    Specified by:
      `toString` in class `Query`

  - ### equals

    public boolean equals(Object o)
    Compares the specified object with this boolean query for equality. Returns true if and only if the provided object
    - is also a `BooleanQuery`,
    - has the same value of `getMinimumNumberShouldMatch()`
    - has the same `BooleanClause.Occur.SHOULD` clauses, regardless of the order
    - has the same `BooleanClause.Occur.MUST` clauses, regardless of the order
    - has the same set of `BooleanClause.Occur.FILTER` clauses, regardless of the order and regardless of duplicates
    - has the same set of `BooleanClause.Occur.MUST_NOT` clauses, regardless of the order and regardless of duplicates
    Specified by:
      `equals` in class `Query`
    See Also:
      - `Query.sameClassAs(Object)`
      - `Query.classHash()`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Query`
    Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.
    Specified by:
      `hashCode` in class `Query`
    See Also:
      - `Query.equals(Object)`